#property copyright "Copyright 2023, QS"
#property link      ""
#property version   "3.50" 

#include <Trade/Trade.mqh>
#include <Trade\DealInfo.mqh>
#include <Trade\OrderInfo.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\AccountInfo.mqh>
#include <Trade\SymbolInfo.mqh>



CAccountInfo   account;
CSymbolInfo    msymbol;  
CPositionInfo  positions;                  
CDealInfo deal;
CTrade trade;
COrderInfo order;


enum TradeT
   {
     Buy,
     Sell,
   
   };
   
   

input bool AutoTrade = false;//Auto Trade
input int Magic = 1234; //Magic Number
int Slippage=3; // Max Slippage (0=Disabled)
input double MaxSpread = 0; // Maximum Spread(0=Disabled)
 //input TradeT ttype = Buy;//Trade Type
 input double Gap =  1;//Pips Between Trades
input double Lot = 0.1;   //Lot Size
input double DailyTarget = 2000;//TP ($)
input double DailyStop = 2000;//SL ($)
double SL = 100;   // Stop Loss (pips)
double TP = 300; //Take Profit (pips)
input int    MaxTrade = 8;//Maximum Number of Trades
string comments ="Additional Trade";
input int    TradeDelay = 5;//Delay After Close (mins)

input bool   UseTrailing = true;
input double trailingStart =40;//Trail ($)
input double trailingStep =20;//Step ($)

//sto



input string A4="================================";//======RSI Settings======
int rsiPeriod = 8;
ENUM_APPLIED_PRICE appliedpricersi = PRICE_CLOSE; // RSI Price
input double RSIBuyLevel = 20;
input double RSISellLevel = 80;


input string L="================================";//======Stochastic Settings======
int  K_period=8; 
int  D_period=3; 
int  Slowing=3;
ENUM_MA_METHOD MA_Method4=MODE_SMA; //Stochastic Method
ENUM_STO_PRICE MA_price4=STO_LOWHIGH;//Stochastic Price
input double StochBuyLevel=5;
input double StochSellLevel= 95;


int handle_rsi,istochastic;



//sto end

input string B8="================================";//======Time Trading======
input string StartTime = "2:00";  //Start Trading
input string StopTime =  "22:00"; //Stop Trading

 bool times;
  
   

int handle_ma ;
int handle_ma2 ;
double mp=1;
double point;
double oldLot;
bool sell;
bool buy;
datetime Starttime;

//bool tchk=false;


int CountDown = 0;
datetime TimeThen = 0;
bool PosSet=false;

double RSI(int shift) {
   double value[];
   if( handle_rsi!=INVALID_HANDLE ) {
      if( CopyBuffer(handle_rsi,0,shift,1,value)>0 ) 
         return(value[0]);
   }
   return(WRONG_VALUE);
}


double Sto(int shift) {
   double value[];
   if( istochastic!=INVALID_HANDLE ) {
      if( CopyBuffer(istochastic,0,shift,1,value)>0 ) 
         return(value[0]);
   }
   return(WRONG_VALUE);
}

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   
    //Label();
    text();
    text2();
    text3();
    
    GetPoint();
    
    handle_rsi = iRSI(NULL,0,rsiPeriod,appliedpricersi);
    istochastic = iStochastic(NULL,0,K_period,D_period,Slowing,MA_Method4,MA_price4);
    
    
   trade.SetDeviationInPoints(3);
   trade.SetExpertMagicNumber(Magic);
  
   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectDelete(0,"right");
   ObjectDelete(0,"right2");
   ObjectDelete(0,"right3");
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
    
    
    //if(NumTrade(2)==0)tchk=true;
    
    if(NumTrade(2)==0 && PosSet==true)
     {
        PosSet=false;
        TimeThen=TimeCurrent();
        
     
     }
 
    if(MQLInfoInteger(MQL_TESTER))
      {
         if(ObjectGetInteger(0,"right",OBJPROP_STATE))
           {
                Tradex(0);
                ObjectSetInteger(0,"right",OBJPROP_STATE,0);
           }
           
         if(ObjectGetInteger(0,"right2",OBJPROP_STATE))
           {
                Tradex(1);
                ObjectSetInteger(0,"right2",OBJPROP_STATE,0);
           }  
           
         
         if(ObjectGetInteger(0,"right3",OBJPROP_STATE))
           {
                {DeletePendingOrders();CloseNow();}
                ObjectSetInteger(0,"right3",OBJPROP_STATE,0);
           }    
         
      }

    
    if(AutoTrade)SetUpIndic();
    
    DailyTarg();
    
    if(UseTrailing)Trail();
    
    if(NumTrade(2)==0 && ordersPen()>0)DeletePendingOrders();

   
  }
//+------------------------------------------------------------------+

void SetUpIndic()
 {
 
     bool buys = RSI(0)<=RSIBuyLevel && Sto(0)<=StochBuyLevel;
     bool sells = RSI(0)>=RSISellLevel && Sto(0)>=StochSellLevel;
     
     
     
     if(ordersPen()==0)
      {
        if(buys && NumTrade(0)==0) Tradex(0);
        if(sells && NumTrade(1)==0) Tradex(1);
      } 
 
 
 }


double CalcDol(int u, double priceopen, double pricecurrent, double vol)
{
   double summ = 0;
   double DollarValue=0;
   
   if(u==1)summ = priceopen-pricecurrent;
   if(u==0)summ = pricecurrent-priceopen;
   
   
   DollarValue = vol * ((summ/_Point)*SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE));

   return (DollarValue);
}

double CalcDol2(int u, double pricesl, double pricecurrent, double vol)
{
   double summ = 0;
   double DollarValue=0;
   
   if(u==1)summ = pricesl-pricecurrent;
   if(u==0)summ = pricecurrent-pricesl;
   
   
   DollarValue = vol * ((summ/_Point)*SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE));

   return (DollarValue);
}

double PipDol(double stepdol, double lot)
 {
     double pips=0;
     
     pips = stepdol/(lot*mp* SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE)) ;
 
  return(pips*mp*_Point);
 }

double Loter()
 {
    double not=0;
    
     for (int num = PositionsTotal() - 1; num >= 0; num--)
       {
         if (positions.SelectByIndex(num))
            {
              if (positions.Magic() == Magic && positions.Symbol()==_Symbol) 
               {
                 not+=positions.Volume();
                
               }   
             }   
         
        }  
 
   return(not);
 }
 

double Take()
 {
 
     double total=0;
     ulong ticket=-1;
     double summ=0;
     double DollarValue=0;
     
   // if(!tchk) 
    
    for (int num = PositionsTotal() - 1; num >= 0; num--)
       {
         if (positions.SelectByIndex(num))
            {
              if (positions.Symbol()==Symbol() && positions.Magic() == Magic) 
               {
                 if(positions.PositionType()==0)
                   {
                     if(positions.StopLoss()<positions.PriceOpen())summ = positions.PriceCurrent()-positions.PriceOpen();
                     if(positions.StopLoss()>=positions.PriceOpen())summ = positions.PriceCurrent()-positions.StopLoss();
                     
                   }  
                   
                 if(positions.PositionType()==1)
                  {
                    if(positions.StopLoss()==0 || positions.StopLoss()>positions.PriceOpen())summ = positions.PriceOpen()-positions.PriceCurrent();
                    if(positions.StopLoss()!=0 && positions.StopLoss()<=positions.PriceOpen())summ = positions.StopLoss()-positions.PriceCurrent();
                  }  
                 
                 DollarValue += positions.Volume() * ((summ/_Point)*SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE));
                 
               }  
            }
        }  
 
   return(DollarValue);
 }

void Trail()
{

 double ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
 double bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
 double stoplevel = (double)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
 double dolamt=0;
 double dolpip=0;
 double parlot=0;
 double pardol=0;
 
 double   totprof = Take();
 double   totlot =  Loter();
 
 //Print("pardol: ");
 
 for(int cnt=PositionsTotal()-1;cnt>=0;cnt--)
   {
       if(!(positions.SelectByIndex(cnt)))continue;
       if(totprof<trailingStart)return;
       
       if(NumTrade(2)>0)PosSet=true;
       
      if(positions.Magic()==Magic && positions.Symbol()==Symbol())
      {
            dolamt=0;
            dolpip=0;
            pardol=0;
            
            pardol=(positions.Volume()/totlot)*trailingStep;
           
            if(positions.PositionType()==POSITION_TYPE_SELL)
              {
                 
                 
                  dolpip=PipDol(pardol,positions.Volume());
                  
                  if(positions.StopLoss() == 0 || ((positions.StopLoss() - ask) > (dolpip + stoplevel*_Point)))
                   {
                     bool mod = trade.PositionModify(PositionGetTicket(cnt), ask+dolpip, positions.TakeProfit());
                     if(!mod)Print("Order modify failed with error: ",GetLastError());
                   }   
                   
              }          
           
            if(positions.PositionType()==POSITION_TYPE_BUY)
               {
                 
                
                    dolpip=PipDol(pardol,positions.Volume()); 
                    if((bid - positions.StopLoss()) > (dolpip + stoplevel*_Point))
                     {
                      bool mod = trade.PositionModify(PositionGetTicket(cnt),bid-dolpip,positions.TakeProfit());
                      if(!mod) Print("Order modify failed with error: ",GetLastError());
                     }   
                
               }        
            }
       }
    
 }



 void text()
 {
      ObjectCreate(0,"right",OBJ_BUTTON,0,0,0);
      ObjectSetString(0,"right",OBJPROP_TEXT,"BUY");
      ObjectSetInteger(0,"right",OBJPROP_COLOR,clrBlack);
      ObjectSetInteger(0,"right",OBJPROP_XSIZE,80);
      ObjectSetInteger(0,"right",OBJPROP_YSIZE,40);
      ObjectSetInteger(0,"right",OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,"right",OBJPROP_XDISTANCE,20);
      ObjectSetInteger(0,"right",OBJPROP_YDISTANCE,50);
      ObjectSetString(0,"right",OBJPROP_FONT,"Arial Bold");
      ObjectSetInteger(0,"right",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"right",OBJPROP_BGCOLOR,clrBlue);
      ObjectSetInteger(0,"right",OBJPROP_ALIGN,ALIGN_LEFT);
      ObjectSetInteger(0,"right",OBJPROP_SELECTABLE,false);
 
 
 }

void text2()
 {
      ObjectCreate(0,"right2",OBJ_BUTTON,0,0,0);
      ObjectSetString(0,"right2",OBJPROP_TEXT,"SELL");
      ObjectSetInteger(0,"right2",OBJPROP_COLOR,clrBlack);
      ObjectSetInteger(0,"right2",OBJPROP_XSIZE,80);
      ObjectSetInteger(0,"right2",OBJPROP_YSIZE,40);
      ObjectSetInteger(0,"right2",OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,"right2",OBJPROP_XDISTANCE,100);
      ObjectSetInteger(0,"right2",OBJPROP_YDISTANCE,50);
      ObjectSetString(0,"right2",OBJPROP_FONT,"Arial Bold");
      ObjectSetInteger(0,"right2",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"right2",OBJPROP_BGCOLOR,clrRed);
      ObjectSetInteger(0,"right2",OBJPROP_ALIGN,ALIGN_LEFT);
      ObjectSetInteger(0,"right2",OBJPROP_SELECTABLE,false);
 
 
 }
 
void text3()
 {
      ObjectCreate(0,"right3",OBJ_BUTTON,0,0,0);
      ObjectSetString(0,"right3",OBJPROP_TEXT,"CLOSE ALL");
      ObjectSetInteger(0,"right3",OBJPROP_COLOR,clrBlack);
      ObjectSetInteger(0,"right3",OBJPROP_XSIZE,160);
      ObjectSetInteger(0,"right3",OBJPROP_YSIZE,40);
      ObjectSetInteger(0,"right3",OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,"right3",OBJPROP_XDISTANCE,20);
      ObjectSetInteger(0,"right3",OBJPROP_YDISTANCE,90);
      ObjectSetString(0,"right3",OBJPROP_FONT,"Arial Bold");
      ObjectSetInteger(0,"right3",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"right3",OBJPROP_BGCOLOR,clrGreen);
      ObjectSetInteger(0,"right3",OBJPROP_ALIGN,ALIGN_LEFT);
      ObjectSetInteger(0,"right3",OBJPROP_SELECTABLE,false);
 
 
 }
 

int ordersPen()
{
 int cnt=0;
   
   for (int num = OrdersTotal() - 1; num >= 0; num--)
       {
         if(order.SelectByIndex(num))
            {
              if (order.Symbol()  == Symbol() && order.Magic() == Magic)cnt++;
            }
        }    
   
    return(cnt);
  }
  

int NumTrade(int g)
   {
      int cnt = 0;
      for (int num = PositionsTotal() - 1; num >= 0; num--) {
         if (PositionGetTicket(num)){
         if (positions.Symbol() != Symbol() || positions.Magic() != Magic) continue;
         if (g==2 && (positions.PositionType()==POSITION_TYPE_BUY || positions.PositionType()==POSITION_TYPE_SELL)) cnt++;
         if (g==0 && positions.PositionType()==POSITION_TYPE_BUY)cnt++; 
         if (g==1 && positions.PositionType()==POSITION_TYPE_SELL)cnt++;
      }
    }
      return (cnt);  
             
   }

void Tradex(int u)
 {
 
    
    if((TimeCurrent()-TimeThen)<TradeDelay*60)
     {
     
       Print("Time Delay Not Exceeded");
       return;
     
     }
    
    
    bool ticket=false;
    double price=0;
    
    if(u==0)
       {
         
          ticket = trade.Buy(Lot,NULL,0, 0, 0,"Trade");
            if(!ticket)Print("Order Buy trade failed: ",GetLastError());
            
          if(ticket)
            {
              price = trade.RequestPrice() - (Gap*mp*_Point);
              ticket = trade.BuyLimit(Lot,price,NULL,0,0,ORDER_TIME_GTC,0,comments);
              
              Pending(0,trade.RequestPrice()); 
            }
              
       }
              
              
        
   if(u==1)
       {
       
          ticket = trade.Sell(Lot,NULL,0, 0, 0,"Trade");
            if(!ticket)Print("Order Sell trade failed: ",GetLastError());
          
          if(ticket)
           {
             price = trade.RequestPrice() + (Gap*mp*_Point);
             ticket = trade.SellLimit(Lot,price,NULL,0,0,ORDER_TIME_GTC,0,comments);
             Pending(1,trade.RequestPrice()); 
           }  
       }
   
 
 }      


void Pending(int u, double pimax)
 {
    bool ticket = false;
    double price=0;
    double lot= Lot*2;
    int n=0;
   
    for(int i=0;i<MaxTrade-2;i++)
     {
         
         if(n==2){n=0;lot = lot*2;}
         
         
         if(u==0)
          {
            price = pimax - ((i+1)*Gap*mp*_Point);
            ticket = trade.BuyLimit(lot,price,NULL,0,0,ORDER_TIME_GTC,0,comments);
            
          }
            
         if(u==1)
          {
            price = pimax + ((i+1)*Gap*mp*_Point);
            ticket = trade.SellLimit(lot,price,NULL,0,0,ORDER_TIME_GTC,0,comments);
          
          }  
           
      
         if(!ticket)Print("Order Buy trade failed: ",GetLastError()); 
         else n++;
         
         
     }       
 
 
   
       
 }



void DailyTarg()
   {
     double total=0;
     ulong ticket=-1;
    
    for (int num = PositionsTotal() - 1; num >= 0; num--)
       {
         if (positions.SelectByIndex(num))
            {
              if (positions.Magic() == Magic) 
               {
                 total+=positions.Profit()+positions.Commission()+positions.Swap();
               }  
            }
        }  
    
   
 
   
   if(total >= DailyTarget)
    {
        DeletePendingOrders();
        CloseNow();
        TimeThen = TimeCurrent();
    } 
     
      
   if(total <= -DailyStop)  
    {
        DeletePendingOrders();
        CloseNow();
    }  
      
   }   
   
   

void CloseNow()
{ 
  for(int in=PositionsTotal()-1;in>=0;in--)
     {
      if(positions.SelectByIndex(in))
        { 
         if(positions.Symbol()==_Symbol && positions.Magic()==Magic)
           {
              trade.PositionClose(positions.Ticket(),-1); 
           }
        } 
     }

}       

   
void DeletePendingOrders()
{
  
  //Print("called");
  
  for (int num = OrdersTotal() - 1; num >= 0; num--)
       {
         if(order.SelectByIndex(num))
            {
              if (order.Symbol()  == Symbol() && order.Magic() == Magic)
                {
                   trade.OrderDelete(order.Ticket());
                }
            }
        }    
}   
  

void Trade(string nm)
   {
      
      if(NumTrade(2)>0)return;
      
      //Print(nm);
      double sl=0;
      double tp=0;
      double lot=0;
      double lot2=0;
      double profit=0;
      bool ticket=false;
      
      if(GetSpread()>MaxSpread && MaxSpread>0)
           {
            Print("Order not opened because spread ("+(string)(GetSpread())+") is higher than max allowed spread ("+(string)MaxSpread);
            return;
           }

      
      if(nm == "buy")
         {
            
           // lot = lots(lot);
            
            sl=0;
            tp=0;
            if(SL!=0)sl=SymbolInfoDouble(NULL,SYMBOL_ASK)-SL*_Point*mp;
            if(TP!=0)tp=SymbolInfoDouble(NULL,SYMBOL_ASK)+TP*_Point*mp;
            ticket = trade.Buy(Lot,NULL,SymbolInfoDouble(NULL,SYMBOL_ASK), sl, tp,"Trade");
            if(!ticket)Print("Order Buy trade failed: ",GetLastError());
          
         }   
        
       if(nm == "sell")
         {
            //lot = lots(lot);
          
            sl=0;
            tp=0;
            if(SL!=0)sl=SymbolInfoDouble(NULL,SYMBOL_BID)+SL*_Point*mp;
            if(TP!=0)tp=SymbolInfoDouble(NULL,SYMBOL_BID)-TP*_Point*mp;
            ticket = trade.Sell(Lot,NULL,SymbolInfoDouble(NULL,SYMBOL_BID), sl, tp, "Trade");
            if(!ticket)Print("Order Sell trade failed: ",GetLastError());
          
         }   
   
   
   }  
    
int format(double d)
   {
     int g;
     g=(int)(d);
     int n=1;
   
     while(g>0)
      {
        g =g/2;
        if(g>0)n+=1;
      }
   
   return(n);
   }
 
double lots(double loy)
   {
      double lotSize=0;
      double lotsStep = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_STEP);
      double minLots =SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MIN);
      double maxLots = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MAX);
      lotSize = MathRound (loy / lotsStep) * lotsStep;
      lotSize = MathMax (minLots, lotSize);
      lotSize = MathMin (maxLots, lotSize);
      
      
      double freeMargin = AccountInfoDouble(ACCOUNT_MARGIN_FREE);
      double margin = 0.0;
      bool ret = OrderCalcMargin(ORDER_TYPE_BUY, Symbol(), lotSize, SymbolInfoDouble(Symbol(),SYMBOL_ASK), margin);
      if(freeMargin - margin <= 0.0 || ret != true || GetLastError() == 4004)Alert("Not Enough Money to open new trade");
         
  
  return(lotSize);
   } 
   
void CheckLastTrade(double &lot, double &profit)
   {
     datetime time=0;
     ulong ticket=-1;
     lot=0;
     profit=0;
     
     HistorySelect(0,TimeCurrent());
       for (int i = HistoryDealsTotal()-1; i>=0 ; i--) 
        {  
   
           ticket = HistoryDealGetTicket(i);
           if (HistoryDealGetInteger(ticket, DEAL_ENTRY) == DEAL_ENTRY_OUT) 
             {  
              if(HistoryDealGetInteger(ticket,DEAL_TIME)>time && HistoryDealGetInteger(ticket,DEAL_TIME)>Starttime)
                 {
                   profit = HistoryDealGetDouble(ticket, DEAL_PROFIT) + HistoryDealGetDouble(ticket, DEAL_COMMISSION) + HistoryDealGetDouble(ticket, DEAL_SWAP);
                   lot = HistoryDealGetDouble(ticket, DEAL_VOLUME);
                 }
              time = (datetime)HistoryDealGetInteger(ticket,DEAL_TIME);  
             }
         }
   
  //if(profit > 0)return(1);
  //if(profit < 0)return(2);
   
   //return(lot);
   
   }            
   
   
void Close(string nm)   
   {
      for (int num = PositionsTotal() - 1; num >= 0; num--) {
         if(PositionGetTicket(num)){
         if(positions.Magic() == Magic)
           {
             if(nm == "sell" && (int)positions.PositionType() ==1)
               {
                 if(!trade.PositionClose(PositionGetInteger(POSITION_TICKET),-1))
                  Print("Failed to close trade: ", GetLastError());
               }
               
             if(nm == "buy" && (int)positions.PositionType() ==0)
               {
                 if(!trade.PositionClose(PositionGetInteger(POSITION_TICKET),-1))
                  Print("Failed to close trade: ", GetLastError());
               }
  
           }
         }  
      }  
   }



void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   
   if(id==CHARTEVENT_OBJECT_CLICK && sparam=="right")
      {
         Tradex(0);
        ObjectSetInteger(0,"right",OBJPROP_STATE,0);
      }
      
   
   if(id==CHARTEVENT_OBJECT_CLICK && sparam=="right2")
      {
         Tradex(1);
        ObjectSetInteger(0,"right2",OBJPROP_STATE,0);
      }   
   
   
    if(id==CHARTEVENT_OBJECT_CLICK && sparam=="right3")
      {
          DeletePendingOrders();CloseNow();
          //CountDown = TradeDelay*60;
          TimeThen = TimeCurrent();
      }    
         
   
 
  }
        
   
   
bool NewBar()
   {
     static datetime prevTime=0;
          datetime lastTime[1];
          if (CopyTime(_Symbol,_Period,0,1,lastTime)==1 && prevTime!=lastTime[0])
          {
               prevTime=lastTime[0];
              
               return(true);
          }
   
   return(false);
   }   
   
   
double GetSpread()
  {
   double poit=Point();
   double spred=(int)SymbolInfoInteger(Symbol(),SYMBOL_SPREAD);
          
   double mul = 1;
   if(poit==0.00001 || poit==0.001)
     {
        mul = 10;
     }
   
   if(StringFind(Symbol(),"XAU")==0)
     {
       mul = 1;
     }

   if(StringFind(Symbol(),"XAG")==0)
     {
       mul = 0.1;
     }

   if(SymbolInfoDouble(_Symbol,SYMBOL_BID)>1000)
     {
       mul = 1;
     }
   
  return (spred / mul);
   
  }

 
double GetPoint()
  {
   double poit=SymbolInfoDouble(NULL,SYMBOL_POINT);
   
   mp = 1;
   if(poit==0.00001 || poit==0.001)
     {
        mp = 10;
     }
   
   if(StringFind(Symbol(),"XAU")==0)
     {
       mp = 1;
     }

   if(StringFind(Symbol(),"XAG")==0)
     {
       mp = 0.1;
     }

   if(SymbolInfoDouble(NULL,SYMBOL_BID)>1000)
     {
       mp = 1;
     }
   
   return(mp);
  }
 

    
string getErrorDesc(int err_code)
  {
//---
   switch(err_code)
     {
      //--- Constant Description
      case ERR_SUCCESS:                      return("The operation completed successfully");
      case ERR_INTERNAL_ERROR:               return("Unexpected internal error");
      case ERR_WRONG_INTERNAL_PARAMETER:     return("Wrong parameter in the inner call of the client terminal function");
      case ERR_INVALID_PARAMETER:            return("Wrong parameter when calling the system function");
      case ERR_NOT_ENOUGH_MEMORY:            return("Not enough memory to perform the system function");
      case ERR_STRUCT_WITHOBJECTS_ORCLASS:   return("The structure contains objects of strings and/or dynamic arrays and/or structure of such objects and/or classes");
      case ERR_INVALID_ARRAY:                return("Array of a wrong type, wrong size, or a damaged object of a dynamic array");
      case ERR_ARRAY_RESIZE_ERROR:           return("Not enough memory for the relocation of an array, or an attempt to change the size of a static array");
      case ERR_STRING_RESIZE_ERROR:          return("Not enough memory for the relocation of string");
      case ERR_NOTINITIALIZED_STRING:        return("Not initialized string");
      case ERR_INVALID_DATETIME:             return("Invalid date and/or time");
      case ERR_ARRAY_BAD_SIZE:               return("Requested array size exceeds 2 GB");
      case ERR_INVALID_POINTER:              return("Wrong pointer");
      case ERR_INVALID_POINTER_TYPE:         return("Wrong type of pointer");
      case ERR_FUNCTION_NOT_ALLOWED:         return("System function is not allowed to call");
      //--- Charts      
      case ERR_CHART_WRONG_ID:               return("Wrong chart ID");
      case ERR_CHART_NO_REPLY:               return("Chart does not respond");
      case ERR_CHART_NOT_FOUND:              return("Chart not found");
      case ERR_CHART_NO_EXPERT:              return("No Expert Advisor in the chart that could handle the event");
      case ERR_CHART_CANNOT_OPEN:            return("Chart opening error");
      case ERR_CHART_CANNOT_CHANGE:          return("Failed to change chart symbol and period");
      case ERR_CHART_CANNOT_CREATE_TIMER:    return("Failed to create timer");
      case ERR_CHART_WRONG_PROPERTY:         return("Wrong chart property ID");
      case ERR_CHART_SCREENSHOT_FAILED:      return("Error creating screenshots");
      case ERR_CHART_NAVIGATE_FAILED:        return("Error navigating through chart");
      case ERR_CHART_TEMPLATE_FAILED:        return("Error applying template");
      case ERR_CHART_WINDOW_NOT_FOUND:       return("Subwindow containing the indicator was not found");
      case ERR_CHART_INDICATOR_CANNOT_ADD:   return("Error adding an indicator to chart");
      case ERR_CHART_INDICATOR_CANNOT_DEL:   return("Error deleting an indicator from the chart");
      case ERR_CHART_INDICATOR_NOT_FOUND:    return("Indicator not found on the specified chart");
      //--- Graphical Objects   
      case ERR_OBJECT_ERROR:                 return("Error working with a graphical object");
      case ERR_OBJECT_NOT_FOUND:             return("Graphical object was not found");
      case ERR_OBJECT_WRONG_PROPERTY:        return("Wrong ID of a graphical object property");
      case ERR_OBJECT_GETDATE_FAILED:        return("Unable to get date corresponding to the value");
      case ERR_OBJECT_GETVALUE_FAILED:       return("Unable to get value corresponding to the date");
      //--- MarketInfo  
      case ERR_MARKET_UNKNOWN_SYMBOL:        return("Unknown symbol");
      case ERR_MARKET_NOT_SELECTED:          return("Symbol is not selected in MarketWatch");
      case ERR_MARKET_WRONG_PROPERTY:        return("Wrong identifier of a symbol property");
      case ERR_MARKET_LASTTIME_UNKNOWN:      return("Time of the last tick is not known (no ticks)");
      case ERR_MARKET_SELECT_ERROR:          return("Error adding or deleting a symbol in MarketWatch");
      //--- History Access      
      case ERR_HISTORY_NOT_FOUND:            return("Requested history not found");
      case ERR_HISTORY_WRONG_PROPERTY:       return("Wrong ID of the history property");
      //--- Global_Variables    
      case ERR_GLOBALVARIABLE_NOT_FOUND:     return("Global variable of the client terminal is not found");
      case ERR_GLOBALVARIABLE_EXISTS:        return("Global variable of the client terminal with the same name already exists");
      case ERR_MAIL_SEND_FAILED:             return("Email sending failed");
      case ERR_PLAY_SOUND_FAILED:            return("Sound playing failed");
      case ERR_MQL5_WRONG_PROPERTY:          return("Wrong identifier of the program property");
      case ERR_TERMINAL_WRONG_PROPERTY:      return("Wrong identifier of the terminal property");
      case ERR_FTP_SEND_FAILED:              return("File sending via ftp failed");
      case ERR_NOTIFICATION_SEND_FAILED:     return("Error in sending notification");
      //--- Custom Indicator Buffers
      case ERR_BUFFERS_NO_MEMORY:            return("Not enough memory for the distribution of indicator buffers");
      case ERR_BUFFERS_WRONG_INDEX:          return("Wrong indicator buffer index");
      //--- Custom Indicator Properties
      case ERR_CUSTOM_WRONG_PROPERTY:        return("Wrong ID of the custom indicator property");
      //--- Account
      case ERR_ACCOUNT_WRONG_PROPERTY:       return("Wrong account property ID");
      case ERR_TRADE_WRONG_PROPERTY:         return("Wrong trade property ID");
      case ERR_TRADE_DISABLED:               return("Trading by Expert Advisors prohibited");
      case ERR_TRADE_POSITION_NOT_FOUND:     return("Position not found");
      case ERR_TRADE_ORDER_NOT_FOUND:        return("Order not found");
      case ERR_TRADE_DEAL_NOT_FOUND:         return("Deal not found");
      case ERR_TRADE_SEND_FAILED:            return("Trade request sending failed");
      //--- Indicators  
      case ERR_INDICATOR_UNKNOWN_SYMBOL:     return("Unknown symbol");
      case ERR_INDICATOR_CANNOT_CREATE:      return("Indicator cannot be created");
      case ERR_INDICATOR_NO_MEMORY:          return("Not enough memory to add the indicator");
      case ERR_INDICATOR_CANNOT_APPLY:       return("The indicator cannot be applied to another indicator");
      case ERR_INDICATOR_CANNOT_ADD:         return("Error applying an indicator to chart");
      case ERR_INDICATOR_DATA_NOT_FOUND:     return("Requested data not found");
      case ERR_INDICATOR_WRONG_HANDLE:       return("Wrong indicator handle");
      case ERR_INDICATOR_WRONG_PARAMETERS:   return("Wrong number of parameters when creating an indicator");
      case ERR_INDICATOR_PARAMETERS_MISSING: return("No parameters when creating an indicator");
      case ERR_INDICATOR_CUSTOM_NAME:        return("The first parameter in the array must be the name of the custom indicator");
      case ERR_INDICATOR_PARAMETER_TYPE:     return("Invalid parameter type in the array when creating an indicator");
      case ERR_INDICATOR_WRONG_INDEX:        return("Wrong index of the requested indicator buffer");
      //--- Depth of Market     
      case ERR_BOOKS_CANNOT_ADD:             return("Depth Of Market can not be added");
      case ERR_BOOKS_CANNOT_DELETE:          return("Depth Of Market can not be removed");
      case ERR_BOOKS_CANNOT_GET:             return("The data from Depth Of Market can not be obtained");
      case ERR_BOOKS_CANNOT_SUBSCRIBE:       return("Error in subscribing to receive new data from Depth Of Market");
      //--- File Operations
      case ERR_TOO_MANY_FILES:               return("More than 64 files cannot be opened at the same time");
      case ERR_WRONG_FILENAME:               return("Invalid file name");
      case ERR_TOO_LONG_FILENAME:            return("Too long file name");
      case ERR_CANNOT_OPEN_FILE:             return("File opening error");
      case ERR_FILE_CACHEBUFFER_ERROR:       return("Not enough memory for cache to read");
      case ERR_CANNOT_DELETE_FILE:           return("File deleting error");
      case ERR_INVALID_FILEHANDLE:           return("A file with this handle was closed, or was not opening at all");
      case ERR_WRONG_FILEHANDLE:             return("Wrong file handle");
      case ERR_FILE_NOTTOWRITE:              return("The file must be opened for writing");
      case ERR_FILE_NOTTOREAD:               return("The file must be opened for reading");
      case ERR_FILE_NOTBIN:                  return("The file must be opened as a binary one");
      case ERR_FILE_NOTTXT:                  return("The file must be opened as a text");
      case ERR_FILE_NOTTXTORCSV:             return("The file must be opened as a text or CSV");
      case ERR_FILE_NOTCSV:                  return("The file must be opened as CSV");
      case ERR_FILE_READERROR:               return("File reading error");
      case ERR_FILE_BINSTRINGSIZE:           return("String size must be specified, because the file is opened as binary");
      case ERR_INCOMPATIBLE_FILE:            return("A text file must be for string arrays, for other arrays - binary");
      case ERR_FILE_IS_DIRECTORY:            return("This is not a file, this is a directory");
      case ERR_FILE_NOT_EXIST:               return("File does not exist");
      case ERR_FILE_CANNOT_REWRITE:          return("File can not be rewritten");
      case ERR_WRONG_DIRECTORYNAME:          return("Wrong directory name");
      case ERR_DIRECTORY_NOT_EXIST:          return("Directory does not exist");
      case ERR_FILE_ISNOT_DIRECTORY:         return("This is a file, not a directory");
      case ERR_CANNOT_DELETE_DIRECTORY:      return("The directory cannot be removed");
      case ERR_CANNOT_CLEAN_DIRECTORY:       return("Failed to clear the directory (probably one or more files are blocked and removal operation failed)");
      case ERR_FILE_WRITEERROR:              return("Failed to write a resource to a file");
      //--- String Casting      
      case ERR_NO_STRING_DATE:               return("No date in the string");
      case ERR_WRONG_STRING_DATE:            return("Wrong date in the string");
      case ERR_WRONG_STRING_TIME:            return("Wrong time in the string");
      case ERR_STRING_TIME_ERROR:            return("Error converting string to date");
      case ERR_STRING_OUT_OF_MEMORY:         return("Not enough memory for the string");
      case ERR_STRING_SMALL_LEN:             return("The string length is less than expected");
      case ERR_STRING_TOO_BIGNUMBER:         return("Too large number, more than ULONG_MAX");
      case ERR_WRONG_FORMATSTRING:           return("Invalid format string");
      case ERR_TOO_MANY_FORMATTERS:          return("Amount of format specifiers more than the parameters");
      case ERR_TOO_MANY_PARAMETERS:          return("Amount of parameters more than the format specifiers");
      case ERR_WRONG_STRING_PARAMETER:       return("Damaged parameter of string type");
      case ERR_STRINGPOS_OUTOFRANGE:         return("Position outside the string");
      case ERR_STRING_ZEROADDED:             return("0 added to the string end, a useless operation");
      case ERR_STRING_UNKNOWNTYPE:           return("Unknown data type when converting to a string");
      case ERR_WRONG_STRING_OBJECT:          return("Damaged string object");
      //--- Operations with Arrays      
      case ERR_INCOMPATIBLE_ARRAYS:          return("Copying incompatible arrays. String array can be copied only to a string array, and a numeric array - in numeric array only");
      case ERR_SMALL_ASSERIES_ARRAY:         return("The receiving array is declared as AS_SERIES, and it is of insufficient size");
      case ERR_SMALL_ARRAY:                  return("Too small array, the starting position is outside the array");
      case ERR_ZEROSIZE_ARRAY:               return("An array of zero length");
      case ERR_NUMBER_ARRAYS_ONLY:           return("Must be a numeric array");
      case ERR_ONEDIM_ARRAYS_ONLY:           return("Must be a one-dimensional array");
      case ERR_SERIES_ARRAY:                 return("Timeseries cannot be used");
      case ERR_DOUBLE_ARRAY_ONLY:            return("Must be an array of type double");
      case ERR_FLOAT_ARRAY_ONLY:             return("Must be an array of type float");
      case ERR_LONG_ARRAY_ONLY:              return("Must be an array of type long");
      case ERR_INT_ARRAY_ONLY:               return("Must be an array of type int");
      case ERR_SHORT_ARRAY_ONLY:             return("Must be an array of type short");
      case ERR_CHAR_ARRAY_ONLY:              return("Must be an array of type char");
      //--- Operations with OpenCL      
      case ERR_OPENCL_NOT_SUPPORTED:         return("OpenCL functions are not supported on this computer");
      case ERR_OPENCL_INTERNAL:              return("Internal error occurred when running OpenCL");
      case ERR_OPENCL_INVALID_HANDLE:        return("Invalid OpenCL handle");
      case ERR_OPENCL_CONTEXT_CREATE:        return("Error creating the OpenCL context");
      case ERR_OPENCL_QUEUE_CREATE:          return("Failed to create a run queue in OpenCL");
      
      
      case ERR_OPENCL_PROGRAM_CREATE:        return("Error occurred when compiling an OpenCL program");
      case ERR_OPENCL_TOO_LONG_KERNEL_NAME:  return("Too long kernel name (OpenCL kernel)");
      case ERR_OPENCL_KERNEL_CREATE:         return("Error creating an OpenCL kernel");
      case ERR_OPENCL_SET_KERNEL_PARAMETER:  return("Error occurred when setting parameters for the OpenCL kernel");
      case ERR_OPENCL_EXECUTE:               return("OpenCL program runtime error");
      case ERR_OPENCL_WRONG_BUFFER_SIZE:     return("Invalid size of the OpenCL buffer");
      case ERR_OPENCL_WRONG_BUFFER_OFFSET:   return("Invalid offset in the OpenCL buffer");
      case ERR_OPENCL_BUFFER_CREATE:         return("Failed to create and OpenCL buffer");
      //--- User-Defined Errors 
      default: if(err_code>=ERR_USER_ERROR_FIRST && err_code<ERR_USER_ERROR_LAST)
                                             return("User error "+string(err_code-ERR_USER_ERROR_FIRST));
     }
//---
   return("Unknown");
  }//--eof ErrorDesc                        
